/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
 /*
 display driver for
 ALPS NEA02040AA
 HCN-111
 94V-0
 LSSDB3011A
 OKI M5260 2369702
 OKI M5298A
 */

#include <avr/io.h>

#include "LCD_alps.h"

char LCD_BUFFER[ Y_res ][ ( X_res / X_pix_per_Byte ) ];

void wr(unsigned char c,unsigned char p){
	unsigned char l;	 // line
	unsigned char b;	 // bit-mask
	unsigned char old,nw;// temporary bytes of video buffer
	b=1<<(7-(c&0x07));	 // bit
	c=(c>>3)%30;		 // byte
	for(l=0;l<Y_res;l++){
		old = LCD_BUFFER[l][c] & ~(b);
		if(p>=l) nw=old|b;
		else	 nw=old;
		LCD_BUFFER[l][c] = nw;
	}
}




void LCD_init( void )
{	
	LCD_PORT |= ( 1<<DI_X ) | ( 1<<CP_X ) | ( 1<<LOAD ) | ( 1<<DI_Y ) | ( 1<<DF ) ;
	LCD_DDR  |= ( 1<<DI_X ) | ( 1<<CP_X ) | ( 1<<LOAD ) | ( 1<<DI_Y ) | ( 1<<DF ) ;		
	for( unsigned char i = 0; i< X_res; i++){
		wr(i,i%Y_res);
	}
}

void LCD_update( void )
{
	static char LCD_DF = 0;
	static char Line = 0;
	static int Pos = 0;
	int i,a;
	unsigned char Data, Temp ;
	Pos = 0;		
	for( i = 0 ; i < ( X_res / X_pix_per_Byte ) ; i++ )
	{
		Data = LCD_BUFFER[ Line ][ Pos++ ]; 
		Temp = LCD_PORT;
		for ( a = 0 ; a < X_pix_per_Byte ; a++ )
		{
			// Kieck mal ob MSB 1 ist
			if ( ( Data & 0x80 ) > 0 )
				LCD_PORT = Temp | ( 1<<DI_X ) | ( 1<<CP_X );
			else
				LCD_PORT = Temp & ~( 1<<DI_X )  | ( 1<<CP_X );			
			Temp = LCD_PORT;
			// SCK auf Low setzen
			LCD_PORT = Temp & ~( 1<<CP_X );			
			Data <<= 1;
		}
	}
	LCD_PORT |= ( 1<<LOAD );
	LCD_PORT &= ~( 1<<LOAD );
	LCD_PORT &= ~( 1<<DI_Y );
	if ( Line == 0 )
	{
		LCD_PORT |= (1<<LOAD );
		Line = Y_res;
		LCD_PORT &= ~(1<<LOAD );		
		if ( LCD_DF == 0 )
		{
			LCD_DF = 1;
			LCD_PORT |= ( 1<<DF );
		}
		else
		{
			LCD_DF = 0;
			LCD_PORT &= ~( 1<<DF );
		}
		LCD_PORT |= (1<<DI_Y );		
	}	
	Line--;	
	return;
}
